package com.link.core.basic.lock;

import java.lang.reflect.Method;
import org.aopalliance.intercept.MethodInvocation;

public class LockAopProxy implements LockAopProxyChain {
   private final MethodInvocation invocation;
   private Method method;

   public LockAopProxy(MethodInvocation invocation) {
      this.invocation = invocation;
   }

   public Object[] getArgs() {
      return this.invocation.getArguments();
   }

   public Object getTarget() {
      return this.invocation.getThis();
   }

   public Method getMethod() {
      if (null == this.method) {
         this.method = this.invocation.getMethod();
      }

      return this.method;
   }

   public Object doProxyChain(Object[] arguments) throws Exception {
      return this.getMethod().invoke(this.invocation.getThis(), arguments);
   }
}
